#!/usr/bin/perl -w

package CleneniDPH;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";
use lib::Dialog;
use lib::Locks;
use lib::Databaze;

my $MyUI;
my %MyMoney;
my $retcode="";
my $CleneniDPH;
my $Locks;

sub upravit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    my $dissable_ok=0;
    $Locks=0;
    if($where) {
        $Locks=new Locks(%MyMoney);
        if(!$Locks->create_lock('r_UcClnDPH',$where)) {
            $dissable_ok=1;
        };
    };
    return($self->run($dissable_ok, $where,0,%params));
};

sub kopirovat {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0, $where,1,%params));
};

sub pridat {
    my ($self, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0,'',0,%params));
};

sub odstranit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('r_UcClnDPH',$where,1)) {
        return(0);
    };
    my $Databaze=new Databaze(%MyMoney);
    if(!$Databaze->Remove("r".$MyMoney{'RokData'}->get('id')."_UcClnDPH",$where)) {
        $Locks->remove_lock;
        return(0);
    };
    $Locks->remove_lock;
    return(1);
};


my @kolonky_vpriznani_dph=(
                           
    # obecne
    ['Neovlivňuje přiznání k DPH','NN'],
    
    # prijata
    ['Přijatá zdaň. plnění z tuzemska - má nárok na odpočet','PT'],
    ['Přijatá zdaň. plnění z tuzemska - krátit nárok na odpočet','KT'],
    ['Pořízení zboží z jiného členského státu','P1'],
    ['Pořízení zboží z jiného členského státu - krác. nár.','K1'],
    ['Poskytnutí služby osobou reg. k dani v jiném člen. státě','P2'],
    ['Poskytnutí služby osobou reg. k dani v jiném člen. státě - krác. nár.','K2'],
    ['Pořízení dopr. prostředku - od osob reg. k dani v jiném čl. státě','P4'],
    ['Pořízení dopr. prostředku - od osob reg. k dani v jiném čl. státě - krác. nár','K4'],
    ['Pořízení dopr. prostředku - od osbob nereg. k dani v jiném čl. státě','P5'],
    ['Pořízení dopr. prostředku - od osob nereg. k dani v jiném čl. státě - krác. nár.','K5'],
    ['Dovoz zboží','P6'],
    ['Dovoz zboží - krác. nár.','K6'],
    ['Poskytnutí služby zahraniční osobou povinnou k dani','P7'],
    ['Poskytnutí služby zahraniční osobou povinnou k dani - krác. nár.','K7'],
    ['Pořízení zboží prostřední osobou (Souhrnné hlášení)','PX'],
    ['Vrácená daň zahraničním fyzickým osobám','VD'],

    # uskutecnena
    ['Uskutečněná zdaň. plnění v tuzemsku','UT'],
    ['Pořízení zboží z jiného člen. státu','R1'],
    ['Poskytnutí služby osobou reg. k dani v jiném člen. státě','R2'],
    ['Zaslání zboží z jiného člen. státu s místem plnění v tuzemsku','R3'],
    ['Pořízení dopr. prostředku - od osob reg. k dani v jiném čl. státě','R4'],
    ['Pořízení dopr. prostředku - od osob nereg. k dani v jiném čl. státě','R5'],
    ['Dovoz zboží','R6'],
    ['Poskytnutí služby zahraniční osobou povinnou k dani','R7'],
    ['Dodání zboží do jiného členského státu','U1'],
    ['Dodání dopr. prostředku - osobě reg. k dani v jiném čl, státě','U3'],
    ['Dodání dopr. prostředku - osobě nereg. k dani v jiném čl. státě','U2'],
    ['Vývoz zboží','VZ'],
    ['Ostatní plnění osvobozená od daně s nárokem na odpočet','U4'],
    ['Uskut. zdan. plnění osvobozená, příp. se zdan. plněním mimo tuzemsko','U0'],
    ['Dodání zboží prostř. osobou (Souhrnné hlášení)','UX']
);

sub run {
    my ($class, $dissable_ok, $where, $kopie, %params) = @_;
    $retcode=0;
    %MyMoney=%params;
    my $window=$class;
    $MyUI=$class;
    my $self=$class;
    $CleneniDPH=new Table('r_UcClnDPH',%MyMoney);
    if(!$kopie) {
        $class->{'where'}=$where;
    } else {
        $class->{'where'}="";
    };
    if($dissable_ok) {
        $window->FORM->{'button_ok'}->set_sensitive(0);
    };

    if($where) {
        if(!$CleneniDPH->load($where,1)) {
            my $Dialog=new Dialog;
            $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
            if($Locks) {
                $Locks->remove_lock;
            };
            return(0);
        };
    };
    # vyrobime option menu s kolonkou v priznani dph
    foreach $_ (@kolonky_vpriznani_dph) {
        my @sl=@{$_};
        $window->FORM->{'kolonka_'.$sl[1]}=new_with_mnemonic Gtk2::MenuItem($sl[0]);
        $window->FORM->{'menu62'}->append($window->FORM->{'kolonka_'.$sl[1]});
        $window->FORM->{'kolonka_'.$sl[1]}->show;
    };
    $MyUI->on_typ_toggled;
    $CleneniDPH->WriteToUI($window->FORM);
    $window->set_kolonka($CleneniDPH->get('kolonka'));
    
    $MyUI=$window;
    $window->TOPLEVEL->set_title('Členění DPH');
    $MyMoney{'MainCfg'}->window_open("CleneniDPH",$self->TOPLEVEL);
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return($retcode);
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("CleneniDPH",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_CleneniDPH_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("CleneniDPH",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {
    $CleneniDPH->ReadFromUI($MyUI->FORM);
    $CleneniDPH->set('kolonka',$MyUI->get_kolonka);
    if(!$CleneniDPH->get('zkrat')) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Zkratka nemůže být prázdná!","type"=>"error");
            return;        
    };

    if($MyUI->{'where'}) {
        if(!$CleneniDPH->update) {
            return;
        };
    } else {
        if(!$CleneniDPH->save(1)) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Záznam nelze uložit!\nZřejmě ukládáte duplicitní klíč.","type"=>"error");
            return;
        };
    };
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("CleneniDPH",$MyUI->TOPLEVEL);
    $retcode=$CleneniDPH;
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub set_kolonka {
    my($self,$kolonka_zkr)=@_;
    my $i=0;
    foreach $_ (@kolonky_vpriznani_dph) {
        my @sl=@{$_};
        if($sl[1] eq $kolonka_zkr) {
            $self->FORM->{'kolonka_option'}->set_history($i);
        };
        $i++;
    };
};

sub get_kolonka {
    my($self)=@_;
    my @sl=@{$kolonky_vpriznani_dph[$self->FORM->{'kolonka_option'}->get_history]};
    return($sl[1]);
};

sub on_typ_toggled {
    my $i=0;
    if($MyUI->FORM->{'typ_P'}->get_active) {
        $MyUI->FORM->{'vbox156'}->hide;
        $MyUI->FORM->{'vbox157'}->hide;
        foreach $_ (@kolonky_vpriznani_dph) {
            my @sl=@{$_};
            if($sl[1]=~/^[NPKV]/) {
                $MyUI->FORM->{'kolonka_'.$sl[1]}->show;
                $i++;
            } else {
                $MyUI->FORM->{'kolonka_'.$sl[1]}->hide;
            };
        };
        $i--;
        if($MyUI->FORM->{'kolonka_option'}->get_history > $i) {
            $MyUI->FORM->{'kolonka_option'}->set_history(0);
        };
    } else {
        $MyUI->FORM->{'vbox156'}->show;
        $MyUI->FORM->{'vbox157'}->show;
        foreach $_ (@kolonky_vpriznani_dph) {
            my @sl=@{$_};
            if($sl[1]=~/^[PKV]/) {
                $MyUI->FORM->{'kolonka_'.$sl[1]}->hide;
                $i++;
            } else {
                $MyUI->FORM->{'kolonka_'.$sl[1]}->show;
            };
            if($MyUI->FORM->{'kolonka_option'}->get_history < $i) {
                $MyUI->FORM->{'kolonka_option'}->set_history(0);
            };
        };
    };
};

1;
