#!/usr/bin/perl -w

package Seznam;

BEGIN {
    use src::MymoneyUI;
};


use strict;

#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

#use Mysql;
use POSIX qw(strftime);

use lib "./";
use lib::Table;
use lib::SeznamDef;
use lib::Dialog;
use lib::Databaze;

use lib::UcetPokladna;
use lib::KonSym;
use lib::PenezniUstav;
use lib::KartaStatu;
use lib::KartaStrediska;
use lib::Cinnost;
use lib::Zakazka;
use lib::CiselnaRada;
use lib::KartaPsc;
use lib::PredkontaceP;
use lib::PredkontaceJ;
use lib::CleneniDPH;
use lib::UcetUctoveOsnovy;
use lib::KartaUcetnihoPohybu;
use lib::FakturaVystavena;
use lib::KartaSkupinyAdresare;


my $COL_TEXT_SIZE=4;
my $COL_PIXBUF_SIZE=2;

sub show {
    my ($self, %params) = @_;
    $self->TOPLEVEL->show;
};

my %MyMoney=();

sub run {
    my($self,$seznam,%params)=@_;

    %MyMoney=@{$params{'cfg'}};
    $self->{'retval'}=0;
    $self->{'seznam'}=$seznam;
    
    # tohle prozatim nechceme ukazovat
    $self->FORM->{'handlebox7'}->hide;
    
    my @selected_rows=();
    my $selected_rows_by="";
    if(defined($params{'ok_butt'})) {
        $self->{'ok_butt'}=$params{'ok_butt'};
        if($params{'selected_rows_by'} && (@{$params{'selected_rows'}})) {
            $selected_rows_by=$params{'selected_rows_by'};
            @selected_rows=@{$params{'selected_rows'}};
        };
        $self->{'empty_butt'}=1;
        if(defined($params{'empty_butt'})) {
            $self->{'empty_butt'}=$params{'empty_butt'};
        };
    } else {
        $self->{'ok_butt'}=0;
    };
    
    $self->{'selected_rows_by'}=$selected_rows_by;
    @{$self->{'selected_rows'}}=@selected_rows;
    
    if(defined($params{'print_butt'})) {
        $self->{'print_butt'}=$params{'print_butt'};
    } else {
        $self->{'print_butt'}=1;
    };
    if(defined($params{'upravit_butt'})) {
        $self->{'upravit_butt'}=$params{'upravit_butt'};
    } else {
        $self->{'upravit_butt'}=1;
    };
    if(defined($params{'pridat_butt'})) {
        $self->{'pridat_butt'}=$params{'pridat_butt'};
    } else {
        $self->{'pridat_butt'}=1;
    };
    if(defined($params{'kopirovat_butt'})) {
        $self->{'kopirovat_butt'}=$params{'kopirovat_butt'};
    } else {
        $self->{'kopirovat_butt'}=1;
    };
    if(defined($params{'delete_butt'})) {
        $self->{'delete_butt'}=$params{'delete_butt'};
    } else {
        $self->{'delete_butt'}=1;
    };
    if(defined($params{'storno_butt'})) {
        $self->{'storno_butt'}=$params{'storno_butt'};
    } else {
        $self->{'storno_butt'}=0;
    };
    if(defined($params{'smazat_butt'})) {
        $self->{'smazat_butt'}=$params{'smazat_butt'};
    } else {
        $self->{'smazat_butt'}=0;
    };
    if(defined($params{'uzamceni_butt'})) {
        $self->{'uzamceni_butt'}=$params{'uzamceni_butt'};
    } else {
        $self->{'uzamceni_butt'}=0;
    };
    my $where="";
    if($params{'where'}) {
        $where=$params{'where'};
    };
    if($params{'sel_type'}) {
        $self->{'seltype'}=$params{'sel_type'};
    } else {
        $self->{'seltype'}='single';
    };
    %{$self->{'checked_rows'}}=();
    $self->{'numrows'}=0;
    @{$self->{'selected_where'}}=();
    
    #
    #  inicializace podle struktury seznamu
    #    
    my %seznam_struct=%{SeznamDef::get($seznam)};
    my @labels=();
    my @DBcolumns=();        

    if($self->{'ok_butt'}) {
        @labels=(" ");
        @DBcolumns=("\'0\'");
    };
    my $i="labels_".$MyMoney{'RokData'}->get('typ_ucetnictvi');
    if(defined($seznam_struct{$i})) {
        push(@labels,@{$seznam_struct{$i}});
        my $i="dbcols_".$MyMoney{'RokData'}->get('typ_ucetnictvi');
        push(@DBcolumns,@{$seznam_struct{$i}});
    } else {
        push(@labels,@{$seznam_struct{"labels"}});
        push(@DBcolumns,@{$seznam_struct{"dbcols"}});
    };
    @{$self->{'labels'}}=@labels;
    @{$self->{'DBcolumns'}}=@DBcolumns;
    my $DBtable=$seznam_struct{"table"};
    if($DBtable=~/^a_/) {
        my $prefix="a".$MyMoney{'AgendaData'}->get('id')."_";
        $DBtable=~s/^a_/${prefix}/;
    };
    if($DBtable=~/^r_/) {
        my $prefix="r".$MyMoney{'RokData'}->get('id')."_";
        $DBtable=~s/^r_/${prefix}/;
    };
    if(!$where) {
        $where=$seznam_struct{"where"};
    };
    
    $self->TOPLEVEL->set_title($seznam_struct{"title"});
    %{$self->{'seznam_struct'}}=%seznam_struct;
    
    #
    # nastaveni buttonu a callbacku
    #
    $self->TOPLEVEL->signal_connect("unrealize"=>"on_Seznam_unrealize",$self);
    if($self->{'ok_butt'}) {
        $self->FORM->{'button_ok'}->signal_connect("clicked"=>"on_button_ok_clicked",$self);
        $self->FORM->{'button_ok'}->show;
        $self->FORM->{'label_oznacene_polozky'}->set_text("0 / 0");
        if($self->{'empty_butt'}) {
            $self->FORM->{'button_empty'}->signal_connect("clicked"=>"on_button_empty_clicked",$self);
            $self->FORM->{'button_empty'}->show;
        } else {
            $self->FORM->{'button_empty'}->hide;
        };
    } else {
        $self->FORM->{'button_ok'}->hide;
        $self->FORM->{'button_empty'}->hide;
        $self->FORM->{'label_oznacene_polozky'}->set_text("0");
    };
    if(defined($seznam_struct{'legenda'})) {
        $self->FORM->{'togglebutton_legenda'}->show;
        $self->FORM->{'togglebutton_legenda'}->signal_connect("toggled"=>"on_togglebutton_legenda_toggled",$self);
        my $Legenda=new Legenda;
        $Legenda->FORM->{$seznam_struct{'legenda'}."_eventbox_separator"}->modify_bg('normal', Gtk2::Gdk::Color->parse("#30a0f0"));
        $Legenda->FORM->{$seznam_struct{'legenda'}."_eventbox_txt"}->modify_bg('normal', Gtk2::Gdk::Color->parse('white'));
        $Legenda->FORM->{$seznam_struct{'legenda'}}->reparent($self->FORM->{'vbox_legenda'});
        if($MyMoney{'MainCfg'}->get("seznam-".$self->{'seznam'}."_legenda")) {
            if($MyMoney{'MainCfg'}->get("seznam-".$self->{'seznam'}."_legenda") eq 'Y') {
                $self->FORM->{'togglebutton_legenda'}->set_active(1);
            } else {
                $self->FORM->{'togglebutton_legenda'}->set_active(0);
            };
        } else {
            $self->FORM->{'togglebutton_legenda'}->set_active(1);
        };
        $self->on_togglebutton_legenda_toggled($self);
    } else {
        $self->FORM->{'togglebutton_legenda'}->hide;
    };
    $self->FORM->{'button_close'}->signal_connect("clicked"=>"on_button_close_clicked",$self);
    if($seznam_struct{'cb_upravit'}) {
        if($self->{'upravit_butt'}) {
            $self->FORM->{'button_upravit'}->signal_connect("clicked"=>"on_button_upravit_clicked",$self);
            $self->FORM->{'button_upravit'}->show;
        } else {
            $self->FORM->{'button_upravit'}->hide;
        };
        if($self->{'pridat_butt'}) {
            $self->FORM->{'button_pridat'}->signal_connect("clicked"=>"on_button_pridat_clicked",$self);
            $self->FORM->{'button_pridat'}->show;
        } else {
            $self->FORM->{'button_pridat'}->hide;
        };
        if($self->{'kopirovat_butt'}) {
            $self->FORM->{'button_kopirovat'}->signal_connect("clicked"=>"on_button_kopirovat_clicked",$self);
            $self->FORM->{'button_kopirovat'}->show;
        } else {
            $self->FORM->{'button_kopirovat'}->hide;
        };
        if($self->{'delete_butt'}) {
            $self->FORM->{'button_odstranit'}->signal_connect("clicked"=>"on_button_odstranit_clicked",$self);
            $self->FORM->{'button_odstranit'}->show;
        } else {
            $self->FORM->{'button_odstranit'}->hide;
        };
    } else {
        $self->FORM->{'button_upravit'}->hide;
        $self->FORM->{'button_pridat'}->hide;
        $self->FORM->{'button_kopirovat'}->hide;
        $self->FORM->{'button_odstranit'}->hide;        
    };
    if($self->{'storno_butt'}) {
        $self->FORM->{'button_storno'}->signal_connect("clicked"=>"on_button_storno_clicked",$self);
        $self->FORM->{'button_storno'}->show;
    } else {
        $self->FORM->{'button_storno'}->hide;
    };
    if($self->{'smazat_butt'}) {
        $self->FORM->{'button_smazat'}->signal_connect("clicked"=>"on_button_smazat_clicked",$self);
        $self->FORM->{'button_smazat'}->show;
    } else {
        $self->FORM->{'button_smazat'}->hide;
    };
    if($self->{'uzamceni_butt'}) {
        $self->FORM->{'button_uzamceni'}->signal_connect("clicked"=>"on_button_uzamceni_clicked",$self);
        $self->FORM->{'button_uzamceni'}->show;
    } else {
        $self->FORM->{'button_uzamceni'}->hide;
    };
    if($self->{'print_butt'}) {
        $self->FORM->{'button_tisk'}->signal_connect("clicked"=>"on_button_tisk_clicked",$self);
        $self->FORM->{'button_tisk'}->show;
    } else {
        $self->FORM->{'button_tisk'}->hide;
    }
#    $self->FORM->{'button_napoveda'}->signal_connect("clicked"=>"",$self);
    
    
    #
    #  Vytvoreni modelu
    #
    my @coltypes=();
    for(my $i=0;$i<@labels;$i++) {
        if(($i==0) && ($self->{'ok_butt'})) {
            push(@coltypes,'Glib::Boolean');
        } else {
            my $pixbuf_col=0;
            if(defined($seznam_struct{'pixbuf'})) {
                my $this_column=$i;
                if($self->{'ok_butt'}) {
                      $this_column++;
                };
                my @DBcolums=@{$self->{'DBcolumns'}};
                foreach $_ (@{$seznam_struct{'pixbuf'}}) {
                    if($_ eq $DBcolums[$this_column]) {
                        $pixbuf_col=1;
                    };
                };
            };
            if($pixbuf_col) {
                push(@coltypes,'Gtk2::Gdk::Pixbuf','Glib::String');
            } else {
                push(@coltypes,'Glib::String','Glib::Boolean','Glib::String','Glib::Int');
            };
        };
    };
    if(defined($seznam_struct{'dbcols_tool'})) {
        foreach $_ (@{$seznam_struct{'dbcols_tool'}}) {
            push(@coltypes,'Glib::String')
        };
    };
    my $model=Gtk2::ListStore->new(@coltypes);
    $self->FORM->{'model'}=$model;
    
    $self->FORM->{'treeview'}=new Gtk2::TreeView($model);
    
    if($self->{'ok_butt'}) {
        $self->FORM->{'treeview'}->signal_connect("row-activated"=>"on_row_activate_ok",$self);
    };
    if((!$self->{'ok_butt'}) && ($seznam_struct{'cb_upravit'}) && ($self->{'upravit_butt'})) {
        $self->FORM->{'treeview'}->signal_connect("row-activated"=>"on_row_activate_upravit",$self);
    };
    if($self->{'ok_butt'}) {
#        $self->FORM->{'treeview'}->signal_connect("start_interactive_search"=>"uncheck_all",$self);
        #$self->FORM->{'treeview'}->signal_connect("unselect_all"=>"uncheck_all",$self);
    };
    $self->FORM->{'treeview'}->set_headers_visible('1');
    $self->FORM->{'treeview'}->set_enable_search('1');
    $self->FORM->{'treeview'}->set_reorderable('0');
    $self->FORM->{'treeview'}->set_rules_hint('1');
    $self->FORM->{'treeview'}->columns_autosize;
    $self->FORM->{'treeview'}->get_selection->set_mode('multiple');
    $self->FORM->{'treeview'}->get_selection->signal_connect('changed',"selection_changed",$self);

    my $j=0;
    my $sorting_column="-1";
    my %column_position=();
    for(my $i=0;$i<@labels;$i++) {
        if(($i==0) && ($self->{'ok_butt'})) {
            $column_position{$DBcolumns[$i]}=$j;
            my $renderer = Gtk2::CellRendererToggle->new;
            my $column = Gtk2::TreeViewColumn->new_with_attributes ($labels[$i],$renderer,active=>$j);
            $column->set_resizable(0);
            $column->set_clickable(0);
            $column->set_sort_column_id($j);
#            $column->set_sort_indicator(0);
#            $column->set_sort_column_id($i);
            
#            $column->add_attribute($renderer_tg,'activatable' => 0);
            $self->FORM->{'treeview'}->append_column ($column);
            $j++;
        } else {
            my $pixbuf_col=0;
            if(defined($seznam_struct{'pixbuf'})) {
                my $this_column=$i;
                if($self->{'ok_butt'}) {
                      $this_column++;
                };
                my @DBcolums=@{$self->{'DBcolumns'}};
                foreach $_ (@{$seznam_struct{'pixbuf'}}) {
                    if($_ eq $DBcolums[$this_column]) {
                        $pixbuf_col=1;
                    };
                };
            };
            if($pixbuf_col) {
                $column_position{$DBcolumns[$i]}=$j;
                my $renderer = Gtk2::CellRendererPixbuf->new;
                my $column = Gtk2::TreeViewColumn->new_with_attributes ($labels[$i],$renderer,pixbuf=>$j);
                $column->set_resizable(0);
                $column->set_clickable(0);
                $column->set_sort_column_id($j);
                $self->FORM->{'treeview'}->append_column ($column);
                $j++;
                $renderer = Gtk2::CellRendererText->new;
                $column = Gtk2::TreeViewColumn->new_with_attributes ($labels[$i],$renderer,text=>$j);
                $column->set_resizable(0);
                $column->set_clickable(0);
                $self->FORM->{'treeview'}->append_column ($column);
                $column->set_visible(0);
                $column->set_sort_column_id($j);
                $j++;
            } else {
                $column_position{$DBcolumns[$i]}=$j;
                if($sorting_column<0) {
                    $sorting_column=$j;
                };
                my $renderer = Gtk2::CellRendererText->new;
                my $column = Gtk2::TreeViewColumn->new_with_attributes ($labels[$i],$renderer,text=>$j,strikethrough=>$j+1,foreground=>$j+2,weight=>$j+3);
                if(defined($seznam_struct{'right_align'})) {
                    my $colname;
                    if($self->{'ok_butt'}) {
                        $colname=$DBcolumns[$i-1];
                    } else {
                        $colname=$DBcolumns[$i];
                    };
                    foreach $_ (@{$seznam_struct{'right_align'}}) {
                        if($_ eq $colname) {
                            my ($cell) = $column->get_cell_renderers;
                            $cell->set (xalign => 1.0);#,foreground=>"red",strikethrough=>1);
                        };
                    };
                };
                #my ($cell) = $column->get_cell_renderers;
                #$cell->set ("size-points" => 10);
                $column->set_resizable(1);
                $column->set_clickable(1);
                $column->set_sort_indicator(0);
                $column->set_sort_column_id($j);
                $column->set_min_width(10);
                $column->signal_connect('clicked',"Seznam::column_clicked",$self);
                $self->FORM->{'treeview'}->append_column ($column);
                $j+=$COL_TEXT_SIZE;
            };
            
        };
    };

    if(defined($seznam_struct{'dbcols_tool'})) {
        foreach $_ (@{$seznam_struct{'dbcols_tool'}}) {
            $column_position{$_}=$j;
            my $renderer = Gtk2::CellRendererText->new;
            my $column = Gtk2::TreeViewColumn->new_with_attributes ($_,$renderer,text=>$j);
            $column->set_resizable(0);
            $column->set_clickable(0);
            $self->FORM->{'treeview'}->append_column ($column);
            $column->set_visible(0);
            $j++;
        };
    };
    
    %{$self->{'column_position'}}=%column_position;
    $self->FORM->{'treeview'}->show;
    $self->FORM->{'scrolledwindow1'}->add($self->FORM->{'treeview'});


    #
    #  Nacteni dat do seznamu
    #
    my $Databaze=new Databaze(%MyMoney);
    my @selcols=@DBcolumns;
    if(defined($seznam_struct{'dbcols_tool'})) {
        push(@selcols,@{$seznam_struct{'dbcols_tool'}});
    };
    if($Databaze->Read($DBtable,$where,@selcols)) {
        for(my $i=0;$i<$Databaze->numrows;$i++) {
            $self->{'numrows'}++;
            #$Databaze->dataseek($i);
            my %row=$Databaze->fetchhash;
            my $iter=$model->append;
            $self->fill_row($iter,%row);
        };
    };


#
# zapneme trideni na prvni sloupec
#
    if($sorting_column>=0) {
        my $column=$self->FORM->{'treeview'}->get_column($sorting_column);
        $column->clicked;
    #    $window->FORM->{'treeview'}->move_column_after($window->FORM->{'treeview'}->get_column(0),$window->FORM->{'treeview'}->get_column(1));
        $column=$self->FORM->{'treeview'}->get_column($sorting_column);
    };
    #$self->selection_changed($self->FORM->{'treeview'}->get_selection,$self);
    $self->show_buttons;
    
    if($selected_rows_by) {
        %{$self->{'checked_rows'}}=(1=>1);
        $self->reorder_checked($self);
        my ($i)=sort {$a <=> $b} (keys(%{$self->{'checked_rows'}}));
        if($i) {
            $self->FORM->{'treeview'}->scroll_to_cell($model->get_path($model->get_iter_from_string($i)));
        };
    }
    $self->show_buttons;

    $self->{'TOPFORM'}=$self->FORM->{'vbox1'};
    $MyMoney{'MainCfg'}->window_open("seznam-".$self->{'seznam'},$self->TOPLEVEL);
    $self->TOPLEVEL->show;
    #
    ## Call initialisation sub
    #$class->app_init($window, %params);
    #
    ## Now let Gtk handle signals
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    #
    #$window->TOPLEVEL->destroy;
    return($self->{'retval'});
};
    

sub fill_row {
    my ($self,$iter, %row)=@_;
    
    my $numcols=@{$self->{'DBcolumns'}};
    my @DBcolumns=@{$self->{'DBcolumns'}};
    my %seznam_struct=%{$self->{'seznam_struct'}};
    my $model=$self->FORM->{'model'};
    my %rewrite=();
    if(defined($seznam_struct{'rewrite'})) {
        %rewrite=%{$seznam_struct{'rewrite'}};
    };
    
    #if($self->{'ok_butt'}) {
    #    $numcols++;
    #};
    my $sloupec=0;
    for(my $j=0;$j<$numcols;$j++) {
        
        my $pixbuf_col=0;
        if(defined($seznam_struct{'pixbuf'})) {
            my $this_column=$j;
            if($self->{'ok_butt'}) {
                  $this_column++;
            };
            my @DBcolums=@{$self->{'DBcolumns'}};
            foreach $_ (@{$seznam_struct{'pixbuf'}}) {
                if($_ eq $DBcolums[$this_column]) {
                    $pixbuf_col=1;
                };
            };
        };
        if($pixbuf_col) {
            my @rewrite_execs=@{$rewrite{$DBcolumns[$j]}};
            my $exec_for_rewrite=$rewrite_execs[0];
            $self->{'rewrite_data'}=$row{$DBcolumns[$j]};
            if((my $pixbuf=$self->$exec_for_rewrite)) {
                $model->set_value($iter, $sloupec,$pixbuf);
            } else {
                $model->set_value($iter, $sloupec,undef);
            };
            $model->set_value($iter, $sloupec+1,$row{$DBcolumns[$j]});
            $sloupec+=$COL_PIXBUF_SIZE;
        } else {
            if($DBcolumns[$j] eq $self->{'selected_rows_by'}) {
                foreach $_ (@{$self->{'selected_rows'}}) {
                    if($_ eq $row{$DBcolumns[$j]}) {
                        $self->{'dissable_changes'}=1;
                        $model->set_value($iter,0,1);
                        $self->FORM->{'treeview'}->get_selection->select_iter($iter);
                        $self->{'dissable_changes'}=0;
                        #$sloupec++;
                    };
                }
            };
            if(defined($rewrite{$DBcolumns[$j]})) {
                if(ref($rewrite{$DBcolumns[$j]}) eq "HASH") {
                    my %rewrite_column=%{$rewrite{$DBcolumns[$j]}};
                    if(defined($rewrite_column{$row{$DBcolumns[$j]}})) {
                        $model->set_value($iter, $sloupec,$rewrite_column{$row{$DBcolumns[$j]}});
                        $sloupec+=$COL_TEXT_SIZE;
                        if($DBcolumns[$j] eq $self->{'selected_rows_by'}) {
                            foreach $_ (@{$self->{'selected_rows'}}) {
                                if($_ eq $rewrite_column{$row{$DBcolumns[$j]}}) {
                                    $self->{'dissable_changes'}=1;
                                    $model->set_value($iter,0,1);
                                    $self->FORM->{'treeview'}->get_selection->select_iter($iter);
                                    $self->{'dissable_changes'}=0;
                                };
                            }
                        };
                    } else {
                        $model->set_value($iter, $sloupec,$row{$DBcolumns[$j]});
                        $sloupec+=$COL_TEXT_SIZE;
                    };
                } else {
                    if(ref($rewrite{$DBcolumns[$j]}) eq "ARRAY") {
                        my @rewrite_execs=@{$rewrite{$DBcolumns[$j]}};
                        my $exec_for_rewrite=$rewrite_execs[0];
                        $self->{'rewrite_data'}=$row{$DBcolumns[$j]};
                        $model->set_value($iter, $sloupec,$self->$exec_for_rewrite);
                        $sloupec+=$COL_TEXT_SIZE;
                    };
                };
            } else {
                #$model->set_value($iter, $sloupec,$row{$DBcolumns[$j]});
                #print("sl=$sloupec, val=".$row{$DBcolumns[$j]}."\n");
                if($j==0 && $self->{'ok_butt'}) {
                    $model->set_value($iter, $sloupec,0);
                    $sloupec++;
                } else {
                    #print("sl=$sloupec, val=".$row{$DBcolumns[$j]}."\n");
                    $model->set_value($iter, $sloupec,$row{$DBcolumns[$j]});
                    $sloupec+=$COL_TEXT_SIZE;
                };
            };
        };
    };
    if(defined($seznam_struct{'dbcols_tool'})) {
        foreach $_ (@{$seznam_struct{'dbcols_tool'}}) {
            $model->set_value($iter, $sloupec,$row{$_});
            $sloupec++;
        };
    };
    if(defined($seznam_struct{'row_attr'})) {
        foreach $_ (@{$seznam_struct{'row_attr'}}) {
            $self->{'attr_model'}=$model;
            $self->{'attr_iter'}=$iter;
            %{$self->{'attr_rowdata'}}=%row;
            $self->$_;
        };
    };

};


sub column_clicked {
    my ($column,$window)=@_;

    $window->reorder_checked($window);
    $window->FORM->{'treeview'}->set_search_column($column->get_sort_column_id);
};


sub show_buttons {
    my ($self)=@_;
    my %seznam_struct=%{$self->{'seznam_struct'}};
    my %button_access;
    if(defined($seznam_struct{'button_access'})) {
        %button_access=%{$seznam_struct{'button_access'}};
    };
    if($self->FORM->{'treeview'}->get_selection->count_selected_rows) {
        if($self->FORM->{'treeview'}->get_selection->count_selected_rows>1) {
            $self->FORM->{'button_upravit'}->set_sensitive(0);
            $self->FORM->{'button_kopirovat'}->set_sensitive(0);
            $self->FORM->{'button_storno'}->set_sensitive(0);
            $self->FORM->{'button_smazat'}->set_sensitive(0);
        } else {
            $self->FORM->{'button_upravit'}->set_sensitive(1);
            if(defined($button_access{'button_kopirovat'})) {
                my $act=$button_access{'button_kopirovat'};
                if($self->$act) {
                    $self->FORM->{'button_kopirovat'}->set_sensitive(1);
                } else {
                    $self->FORM->{'button_kopirovat'}->set_sensitive(0);
                };
            } else {
                $self->FORM->{'button_kopirovat'}->set_sensitive(1);
            };
            if(defined($button_access{'button_storno'})) {
                my $act=$button_access{'button_storno'};
                if($self->$act) {
                    $self->FORM->{'button_storno'}->set_sensitive(1);
                } else {
                    $self->FORM->{'button_storno'}->set_sensitive(0);
                };
            } else {
                $self->FORM->{'button_storno'}->set_sensitive(1);
            };
            if(defined($button_access{'button_smazat'})) {
                my $act=$button_access{'button_smazat'};
                if($self->$act) {
                    $self->FORM->{'button_smazat'}->set_sensitive(1);
                } else {
                    $self->FORM->{'button_smazat'}->set_sensitive(0);
                };
            } else {
                $self->FORM->{'button_smazat'}->set_sensitive(1);
            };
        };
        $self->FORM->{'button_odstranit'}->set_sensitive(1);
        $self->FORM->{'button_uzamceni'}->set_sensitive(1);
    } else {
        $self->FORM->{'button_upravit'}->set_sensitive(0);
        $self->FORM->{'button_kopirovat'}->set_sensitive(0);
        $self->FORM->{'button_odstranit'}->set_sensitive(0);
        $self->FORM->{'button_storno'}->set_sensitive(0);
        $self->FORM->{'button_smazat'}->set_sensitive(0);
        $self->FORM->{'button_uzamceni'}->set_sensitive(0);
    };
    if((keys(%{$self->{'checked_rows'}}))) {
        $self->FORM->{'button_ok'}->set_sensitive(1);
    } else {
        $self->FORM->{'button_ok'}->set_sensitive(0);
    };
};


sub selection_changed {
    shift;
    my ($self)=@_;
    
    if($self->{'dissable_changes'}) {
        return;
    };
    my $selection=$self->FORM->{'treeview'}->get_selection;
    my $window=$self;
    my %checked_rows=%{$self->{'checked_rows'}};
    #if($selection->count_selected_rows==1) {
    #    my $path=$selection->get_selected_rows;
    #    my ($model,$iter)=$selection->get_selected;
    #    print($model->get($iter,1)."\n");
    #    $window->FORM->{'treeview'}->scroll_to_cell($path);
    #};
    #show_buttons($window);
    
    if($self->{'ok_butt'}) {
        my($path,$column)=$window->FORM->{'treeview'}->get_cursor;
        #if($column->get_sort_column_id==-1) { #pokud se kliknulo na prvni sloupec s checkboxy
        
        my $iter=$window->FORM->{'model'}->get_iter($path);
        if($window->FORM->{'model'}->get_value($iter,0)==1) {
            $window->FORM->{'model'}->set_value($iter,0,0);
            delete($checked_rows{$path->get_indices});
        } else {
            $window->FORM->{'model'}->set_value($iter,0,1);
            if($self->{'seltype'} eq 'single') {
                foreach $_ (keys(%checked_rows)) {
                    my $uncheck_path=Gtk2::TreePath->new_from_indices($_);
                    my $iter=$window->FORM->{'model'}->get_iter($uncheck_path);
                    $window->FORM->{'model'}->set_value($iter,0,0);
                    delete($checked_rows{$_});
                };
            };
            $checked_rows{$path->get_indices}=1;
        };
    };
    %{$self->{'checked_rows'}}=%checked_rows;
    if($self->{'ok_butt'}) {
        $window->FORM->{'label_oznacene_polozky'}->set_text((keys(%checked_rows))." / ".$selection->count_selected_rows);
    } else {
        $window->FORM->{'label_oznacene_polozky'}->set_text($selection->count_selected_rows);
    };
    $window->show_buttons;

};

sub reorder_checked {
    shift;
    my($self)=@_;
    if((keys(%{$self->{'checked_rows'}}))) {
        my %checked_rows=();
        for(my $i=0;$i<$self->{'numrows'};$i++) {
            my $path=Gtk2::TreePath->new_from_indices($i);
            my $iter=$self->FORM->{'model'}->get_iter($path);
            if($self->FORM->{'model'}->get_value($iter,0,0)) {
                $checked_rows{$i}=1;
            };
        };
        %{$self->{'checked_rows'}}=%checked_rows;
        if($self->{'ok_butt'}) {
            $self->FORM->{'label_oznacene_polozky'}->set_text((keys(%checked_rows))." / ".$self->FORM->{'treeview'}->get_selection->count_selected_rows);
        } else {
            $self->FORM->{'label_oznacene_polozky'}->set_text($self->FORM->{'treeview'}->get_selection->count_selected_rows);
        };
    };
};

sub on_row_activate_ok {
    my($treeview,$path,$column,$self)=@_;
    my %checked;
    $checked{$path->get_indices}=1;
    %{$self->{'checked_rows'}}=%checked;
    $self->on_button_ok_clicked($self);
};

sub get_where {
    my($self,$iter)=@_;

    my %seznam_struct=%{$self->{'seznam_struct'}};
    my $model=$self->FORM->{'treeview'}->get_model;
    my @DBcolumns=@{$self->{'DBcolumns'}};
    my %rewrite=();
    if(defined($seznam_struct{'rewrite'})) {
        %rewrite=%{$seznam_struct{'rewrite'}};
    };
    my $where="";
    my $start_col=0;
    my $sloupec=0;
    if($self->{'ok_butt'}) {
        $start_col=1;
        $sloupec=1;
    };
    
    if(!defined($seznam_struct{'primary_column'})) {
        for(my $i=$start_col;$i<@DBcolumns;$i++) {
            if($where) {
                $where.=" AND ";
            };
            if(defined($rewrite{$DBcolumns[$i]})) {
                #my @rewrite_column=%{$rewrite{$DBcolumns[$i]}};
                #my $rewrited=0;
                #my $where_r="";
                #for(my $j=1;$j<@rewrite_column;$j+=2) {
                #    if($rewrite_column[$j] eq $model->get($iter,$i)) {
                #        $where_r=$DBcolumns[$i]."='".$rewrite_column[$j-1]."'";
                #        $rewrited++;
                #    };
                #};
    
                my $rewrited=0;
                my $where_r="";
                if(ref($rewrite{$DBcolumns[$i]}) eq "HASH") {
                    my @rewrite_column=%{$rewrite{$DBcolumns[$i]}};
                    for(my $j=1;$j<@rewrite_column;$j+=2) {
                        if($rewrite_column[$j] eq $self->FORM->{'model'}->get($iter,$sloupec)) {
                            $where_r=$DBcolumns[$i]."='".$rewrite_column[$j-1]."'";
                            $rewrited++;
                        };
                    };
                } else {
                    if(ref($rewrite{$DBcolumns[$i]}) eq "ARRAY") {
                        my @rewrite_execs=@{$rewrite{$DBcolumns[$i]}};
                        my $exec_for_rewrite=$rewrite_execs[1];
                        $self->{'rewrite_data'}=$self->FORM->{'model'}->get($iter,$sloupec);
                        $where_r=$DBcolumns[$i]."='".$self->$exec_for_rewrite."'";
                        $rewrited++;
                    };
                };
                
                if(!$rewrited) {
                    $where.=$DBcolumns[$i]."='".$model->get($iter,$sloupec)."'";
                } else {
                    if($rewrited==1) {
                        $where.=$where_r;
                    } else {
                        $where=~s/ AND $//;
                    };
                };
            } else {
                $where.=$DBcolumns[$i]."='".$model->get($iter,$sloupec)."'";
            };
            my $pixbuf_col=0;
            if(defined($seznam_struct{'pixbuf'})) {
                my $this_column=$i;
                if($self->{'ok_butt'}) {
                      $this_column++;
                };
                my @DBcolums=@{$self->{'DBcolumns'}};
                foreach $_ (@{$seznam_struct{'pixbuf'}}) {
                    if($_ eq $DBcolums[$this_column]) {
                        $pixbuf_col=1;
                    };
                };
            };
            if($pixbuf_col) {
                $sloupec+=$COL_PIXBUF_SIZE;
            } else {
                $sloupec+=$COL_TEXT_SIZE;
            };
        };
    } else {
        for(my $i=$start_col;$i<@DBcolumns;$i++) {
            if($DBcolumns[$i] eq $seznam_struct{'primary_column'}) {
                $where=$DBcolumns[$i]."='".$model->get($iter,$sloupec)."'";
            };
            my $pixbuf_col=0;
            if(defined($seznam_struct{'pixbuf'})) {
                my $this_column=$i;
                if($self->{'ok_butt'}) {
                      $this_column++;
                };
                my @DBcolums=@{$self->{'DBcolumns'}};
                foreach $_ (@{$seznam_struct{'pixbuf'}}) {
                    if($_ eq $DBcolums[$this_column]) {
                        $pixbuf_col=1;
                    };
                };
            };
            if($pixbuf_col) {
                $sloupec+=$COL_PIXBUF_SIZE;
            } else {
                $sloupec+=$COL_TEXT_SIZE;
            };
        };
        if(!$where) {
            foreach $_ (@{$seznam_struct{'dbcols_tool'}}) {
                if($_ eq $seznam_struct{'primary_column'}) {
                    $where=$_."='".$model->get($iter,$sloupec)."'";
                };
                $sloupec++;
            };
        };
    };
    return($where);
};

sub on_button_ok_clicked {
    shift;
    my($self)=@_;
    my %seznam_struct=%{$self->{'seznam_struct'}};
    my @selected_where=();
    my @DBcolumns=@{$self->{'DBcolumns'}};
    my %rewrite=();
    my $model=$self->FORM->{'model'};
    if(defined($seznam_struct{'rewrite'})) {
        %rewrite=%{$seznam_struct{'rewrite'}};
    };
    foreach $_ (keys(%{$self->{'checked_rows'}})) {
        my $path=Gtk2::TreePath->new_from_indices($_);
        my $iter=$self->FORM->{'model'}->get_iter($path);
        my $where=$self->get_where($iter);
        push(@selected_where,$where);
    };
    @{$self->{'selected_where'}}=@selected_where;
    $MyMoney{'MainCfg'}->window_close("seznam-".$self->{'seznam'},$self->TOPLEVEL);
    $self->{'retval'}=1;
    $self->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_button_empty_clicked {
    shift;
    my($self)=@_;
    @{$self->{'selected_where'}}=();
    $MyMoney{'MainCfg'}->window_close("seznam-".$self->{'seznam'},$self->TOPLEVEL);
    $self->{'retval'}=1;
    $self->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub selected_where {
    my $self=shift;
    return(@{$self->{'selected_where'}});
};

sub on_row_activate_upravit {
    my($treeview,$path,$column,$self)=@_;
    $self->on_button_upravit_clicked($self,$path);
};


sub on_button_upravit_clicked {
    shift;
    my($self,$path)=@_;

    $self->{'TOPFORM'}->set_sensitive(0);
    my %seznam_struct=%{$self->{'seznam_struct'}};
    if(!$path) {
        $path=$self->FORM->{'treeview'}->get_selection->get_selected_rows;
    };
    my $model=$self->FORM->{'treeview'}->get_model;
    my @DBcolumns=@{$self->{'DBcolumns'}};
    my $iter=$model->get_iter($path);

    my $where=$self->get_where($iter);
    
    my $Upravit=$seznam_struct{'cb_upravit'}->new;
    if((my $Table=$Upravit->upravit($where,%MyMoney))) {
        $self->{'dissable_changes'}=1;
        my %row;
        foreach $_ (@DBcolumns,@{$seznam_struct{'dbcols_tool'}}) {
            $row{$_}=$Table->get($_);
        };
        $self->fill_row($iter,%row);
        $self->reorder_checked($self);
        $self->{'dissable_changes'}=0;
        #$self->selection_changed($self);
        $self->show_buttons;
        $self->FORM->{'treeview'}->scroll_to_cell($model->get_path($iter));
    };
    $self->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_pridat_clicked {
    shift;
    my($self)=@_;
    $self->{'TOPFORM'}->set_sensitive(0);
    my %seznam_struct=%{$self->{'seznam_struct'}};
    my $Upravit=$seznam_struct{'cb_upravit'}->new;
    if((my $Table=$Upravit->pridat(%MyMoney))) {
        $self->{'numrows'}++;
        $self->{'dissable_changes'}=1;
        my $model=$self->FORM->{'treeview'}->get_model;
        my @DBcolumns=@{$self->{'DBcolumns'}};
        my $iter=$model->append;
        $self->{'dissable_changes'}=1;
        my %row;
        foreach $_ (@DBcolumns,@{$seznam_struct{'dbcols_tool'}}) {
            $row{$_}=$Table->get($_);
        };
        $self->fill_row($iter,%row);
        $self->reorder_checked($self);
        $self->{'dissable_changes'}=0;
        #$self->selection_changed($self);
        $self->show_buttons;

        #if($self->{'ok_butt'}) {
        #    $model->set_value($iter,0,1);
        #};
        $self->FORM->{'treeview'}->scroll_to_cell($model->get_path($iter));
       
    };
    $self->{'TOPFORM'}->set_sensitive(1);
};



sub on_button_kopirovat_clicked {
    shift;
    my($self,$path)=@_;

    $self->{'TOPFORM'}->set_sensitive(0);
    my %seznam_struct=%{$self->{'seznam_struct'}};
    if(!$path) {
        $path=$self->FORM->{'treeview'}->get_selection->get_selected_rows;
    };
    my $model=$self->FORM->{'treeview'}->get_model;
    my @DBcolumns=@{$self->{'DBcolumns'}};
    my $iter=$model->get_iter($path);
    my $where=$self->get_where($iter);    
    my $Upravit=$seznam_struct{'cb_upravit'}->new;
    if((my $Table=$Upravit->kopirovat($where,%MyMoney))) {
        $self->{'numrows'}++;
        $self->{'dissable_changes'}=1;
        my $model=$self->FORM->{'treeview'}->get_model;
        my @DBcolumns=@{$self->{'DBcolumns'}};
        my $iter=$model->append;
        $self->{'dissable_changes'}=1;
        my %row;
        foreach $_ (@DBcolumns,@{$seznam_struct{'dbcols_tool'}}) {
            $row{$_}=$Table->get($_);
        };
        $self->fill_row($iter,%row);
        $self->reorder_checked($self);
        $self->{'dissable_changes'}=0;

        #$self->selection_changed($self);
        $self->show_buttons;

        #if($self->{'ok_butt'}) {
        #    $model->set_value($iter,0,1);
        #};
        $self->FORM->{'treeview'}->scroll_to_cell($model->get_path($iter));
    };
    $self->{'TOPFORM'}->set_sensitive(1);
};




sub on_button_odstranit_clicked {
    shift;
    my($self)=@_;
    my %seznam_struct=%{$self->{'seznam_struct'}};
    my $Upravit=$seznam_struct{'cb_upravit'}->new(%MyMoney);
    
    my $Dialog=new Dialog;
    if($Dialog->show('text'=>'Opravdu chcete smazat oznacene zaznamy?','type'=>'question')) {
        my %seznam_struct=%{$self->{'seznam_struct'}};
        my @paths=$self->FORM->{'treeview'}->get_selection->get_selected_rows;
        my $model=$self->FORM->{'treeview'}->get_model;
        my @DBcolumns=@{$self->{'DBcolumns'}};

        my $err=0;
        for(my $j=(@paths-1); $j>=0; $j--) {
            my $path=$paths[$j];
            my $iter=$model->get_iter($path);
            my $where=$self->get_where($iter);            
            if((my $Table=$Upravit->odstranit($where,%MyMoney))) {
                $self->{'dissable_changes'}=1;
                $model->remove($iter);
                $self->{'dissable_changes'}=0;
            } else {
                $err++;
            };

        };
        if($err) {
            my $Dialog=new Dialog;
            $Dialog->show('text'=>"Nektere zaznamy se nepodarilo smazat.\nZrejme byl zaznam uzamcen, nebo zmenen jinym uzivatelem.",'type'=>'info');
        };
        $self->reorder_checked($self);
        #$self->selection_changed($self);
        $self->show_buttons;
    };
};

sub on_button_close_clicked {
    shift;
    my($self)=@_;
    $MyMoney{'MainCfg'}->window_close("seznam-".$self->{'seznam'},$self->TOPLEVEL);
    $self->{'retval'}=0;
    $self->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_Seznam_unrealize {
    shift;
    my($self)=@_;
    $MyMoney{'MainCfg'}->window_close("seznam-".$self->{'seznam'},$self->TOPLEVEL);
    $self->{'retval'}=0;
    Gtk2->main_quit;
};

sub on_togglebutton_legenda_toggled {
    shift;
    my ($self)=@_;
    if($self->FORM->{'togglebutton_legenda'}->get_active) {
        $self->FORM->{'vbox_legenda'}->show;
        $MyMoney{'MainCfg'}->set("seznam-".$self->{'seznam'}."_legenda",'Y');
    } else {
        $self->FORM->{'vbox_legenda'}->hide;
        $MyMoney{'MainCfg'}->set("seznam-".$self->{'seznam'}."_legenda",'N');
    };
};

sub on_button_uzamceni_clicked {
    my $button=shift;
    my($self)=@_;
    
    my $MenuUzamceniDokladu=new MenuUzamceniDokladu;
    $MenuUzamceniDokladu->FORM->{'item258'}->signal_connect("activate","zamceni_dokladu",$self);
    $MenuUzamceniDokladu->FORM->{'item259'}->signal_connect("activate","zruseni_zamku",$self);
    $MenuUzamceniDokladu->TOPLEVEL->popup(undef, # parent menu shell
                 undef, # parent menu item
                 undef, # menu pos func
                 undef, # data
                 $button,
                 0);
};

sub zamceni_dokladu {
    shift;
    my($self)=@_;
    my %seznam_struct=%{$self->{'seznam_struct'}};
    my $Upravit=$seznam_struct{'cb_upravit'}->new;
    my @paths=$self->FORM->{'treeview'}->get_selection->get_selected_rows;
    my $model=$self->FORM->{'treeview'}->get_model;
    my @DBcolumns=@{$self->{'DBcolumns'}};

    my $err=0;
    for(my $j=(@paths-1); $j>=0; $j--) {
        my $path=$paths[$j];
        my $iter=$model->get_iter($path);
        my $where=$self->get_where($iter);
        if((my @Doklady=$Upravit->uzamceni_dokladu($where,%MyMoney))) {
            $self->{'dissable_changes'}=0;
            foreach my $Table (@Doklady) {
                my %row;
                foreach $_ (@DBcolumns,@{$seznam_struct{'dbcols_tool'}}) {
                    $row{$_}=$Table->get($_);
                };
                $self->fill_row($iter,%row);
                $self->reorder_checked($self);            
            };
            $self->{'TOPFORM'}->set_sensitive(1);
            #$self->selection_changed($self);
            $self->show_buttons;
        } else {
            $err++;
        };
    };
    if($err) {
        my $Dialog=new Dialog;
        $Dialog->show('text'=>"Nektere doklady se nepodarilo uzamknout.\nZrejme byl zaznam zablokovan, nebo zmenen jinym uzivatelem.",'type'=>'info');
    };
};

sub zruseni_zamku {
    shift;
    my($self)=@_;
    my %seznam_struct=%{$self->{'seznam_struct'}};
    my $Upravit=$seznam_struct{'cb_upravit'}->new;
    my @paths=$self->FORM->{'treeview'}->get_selection->get_selected_rows;
    my $model=$self->FORM->{'treeview'}->get_model;
    my @DBcolumns=@{$self->{'DBcolumns'}};

    my $err=0;
    for(my $j=(@paths-1); $j>=0; $j--) {
        my $path=$paths[$j];
        my $iter=$model->get_iter($path);
        my $where=$self->get_where($iter);
        if((my @Doklady=$Upravit->zruseni_zamku($where,%MyMoney))) {
            $self->{'dissable_changes'}=0;
            foreach my $Table (@Doklady) {
                my %row;
                foreach $_ (@DBcolumns,@{$seznam_struct{'dbcols_tool'}}) {
                    $row{$_}=$Table->get($_);
                };
                $self->fill_row($iter,%row);
                $self->reorder_checked($self);            
            };
            $self->{'TOPFORM'}->set_sensitive(1);
            #$self->selection_changed($self);
            $self->show_buttons;
        } else {
            $err++;
        };
    };
    if($err) {
        my $Dialog=new Dialog;
        $Dialog->show('text'=>"U nekterych dokladu se nepodarilo odstranit zamek.\nZrejme byl zaznam zablokovan, nebo zmenen jinym uzivatelem.",'type'=>'info');
    };
};

#
# Smazat - zn. oznacit jako smazane, ale neodstranit ze seznamu!
#
sub on_button_smazat_clicked {
    shift;
    my($self,$path)=@_;

    $self->{'TOPFORM'}->set_sensitive(0);
    my %seznam_struct=%{$self->{'seznam_struct'}};
    if(!$path) {
        $path=$self->FORM->{'treeview'}->get_selection->get_selected_rows;
    };
    my $model=$self->FORM->{'treeview'}->get_model;
    my @DBcolumns=@{$self->{'DBcolumns'}};
    my $iter=$model->get_iter($path);

    my $where=$self->get_where($iter);
    
    my $Upravit=$seznam_struct{'cb_upravit'}->new;
    if((my $result=$Upravit->smazat($where,%MyMoney))) {
        if(ref($result) eq "ARRAY") {
            # smazali jsme stornovaci fakturu, tzn, ze musime upravit i radek s fakturou stornovanou (pokud je v seznamu)
            my $i=0;
            foreach my $Table (@{$result}) {
                if($i==0) {
                    # radek smazane storno faktury
                    $self->{'dissable_changes'}=1;
                    my %row;
                    foreach $_ (@DBcolumns,@{$seznam_struct{'dbcols_tool'}}) {
                        $row{$_}=$Table->get($_);
                    };
                    $self->fill_row($iter,%row);
                    $self->reorder_checked($self);
                    $self->{'dissable_changes'}=0;
                    #$self->selection_changed($self);
                    $self->show_buttons;
                    $self->FORM->{'treeview'}->scroll_to_cell($model->get_path($iter));
                } else {
                    #radek [od]stornovane faktury
                    if(defined($seznam_struct{'primary_column'})) {
                        my $primary_column=$seznam_struct{'primary_column'};
                        my %column_position=%{$self->{'column_position'}};
                        my $primary_column_id=$column_position{$primary_column};
                        
                        for(my $j=0;$j<$self->{'numrows'};$j++) {
                            my $path=Gtk2::TreePath->new_from_indices($j);
                            my $iter=$self->FORM->{'model'}->get_iter($path);
                            if($self->FORM->{'model'}->get_value($iter,$primary_column_id) eq $Table->get($primary_column)) {
                                $self->{'dissable_changes'}=1;
                                my %row;
                                foreach $_ (@DBcolumns,@{$seznam_struct{'dbcols_tool'}}) {
                                    $row{$_}=$Table->get($_);
                                };
                                $self->fill_row($iter,%row);
                                $self->reorder_checked($self);
                                $self->{'dissable_changes'}=0;
                                #$self->selection_changed($self);
                                $self->show_buttons;
                                $self->{'TOPFORM'}->set_sensitive(1);
                                return;
                            };                        
                        };
                    };
                };
                $i++;
            };
        } else {
            my $Table=$result;
            $self->{'dissable_changes'}=1;
            my %row;
            foreach $_ (@DBcolumns,@{$seznam_struct{'dbcols_tool'}}) {
                $row{$_}=$Table->get($_);
            };
            $self->fill_row($iter,%row);
            $self->reorder_checked($self);
            $self->{'dissable_changes'}=0;
            #$self->selection_changed($self);
            $self->show_buttons;
            $self->FORM->{'treeview'}->scroll_to_cell($model->get_path($iter));
        };
    };
    $self->{'TOPFORM'}->set_sensitive(1);
};


sub on_button_storno_clicked {
    shift;
    my($self,$path)=@_;

    $self->{'TOPFORM'}->set_sensitive(0);
    my %seznam_struct=%{$self->{'seznam_struct'}};
    if(!$path) {
        $path=$self->FORM->{'treeview'}->get_selection->get_selected_rows;
    };
    my $model=$self->FORM->{'treeview'}->get_model;
    my @DBcolumns=@{$self->{'DBcolumns'}};
    my $iter=$model->get_iter($path);
    my $where=$self->get_where($iter);    
    my $Upravit=$seznam_struct{'cb_upravit'}->new;

    if((my @Tables=@{$Upravit->storno($where,%MyMoney)})) {
        # provedeme zmeny v seznamu u stornovaneho dokladu
        my $Table=$Tables[0];
        $self->{'dissable_changes'}=1;
        my %row;
        foreach $_ (@DBcolumns,@{$seznam_struct{'dbcols_tool'}}) {
            $row{$_}=$Table->get($_);
        };
        $self->fill_row($iter,%row);
        $self->reorder_checked($self);
        $self->{'dissable_changes'}=0;
        #$self->selection_changed($self);
        $self->show_buttons;
        $self->{'TOPFORM'}->set_sensitive(1);
        
        # pridame do seznamu stornovaci doklad
        $Table=$Tables[1];
        $self->{'numrows'}++;
        $self->{'dissable_changes'}=1;
        my $model=$self->FORM->{'treeview'}->get_model;
        my @DBcolumns=@{$self->{'DBcolumns'}};
        my $iter=$model->append;
        $self->{'dissable_changes'}=1;
        %row=();
        foreach $_ (@DBcolumns,@{$seznam_struct{'dbcols_tool'}}) {
            $row{$_}=$Table->get($_);
        };
        $self->fill_row($iter,%row);
        $self->reorder_checked($self);
        $self->{'dissable_changes'}=0;

        #$self->selection_changed($self);
        $self->show_buttons;

        #if($self->{'ok_butt'}) {
        #    $model->set_value($iter,0,1);
        #};
        $self->FORM->{'treeview'}->scroll_to_cell($model->get_path($iter));
    };
    $self->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_tisk_clicked {
    my $button=shift;
    my ($self)=@_;
    my %seznam_struct=%{$self->{'seznam_struct'}};
    my @DBcolumns=@{$self->{'DBcolumns'}};
    my @paths=$self->FORM->{'treeview'}->get_selection->get_selected_rows;
    my $model=$self->FORM->{'treeview'}->get_model;
    my @selected_where=();
    my @checked_where=();

    for(my $j=(@paths-1); $j>=0; $j--) {
        my $path=$paths[$j];
        my $iter=$model->get_iter($path);
        my $where=$self->get_where($iter);
        push(@selected_where,$where);
    };
    foreach $_ (keys(%{$self->{'checked_rows'}})) {
        my $path=Gtk2::TreePath->new_from_indices($_);
        my $iter=$self->FORM->{'model'}->get_iter($path);
        my $where=$self->get_where($iter);
        push(@checked_where,$where);
    };
    
    if($seznam_struct{'printing_menu'}) {
        my $Upravit=$seznam_struct{'cb_upravit'}->new;
        $Upravit->printing($self,$button,@selected_where,@checked_where);
    } else {
        
        my %print_table=();
        
        $print_table{'title'}=$seznam_struct{'title'};
        @{$print_table{'data_header'}}=@{$self->{'labels'}};
        @{$print_table{'data'}}=();
          
        for(my $i=0;$i<$self->{'numrows'};$i++) {
            my $path=Gtk2::TreePath->new_from_indices($i);
            my $iter=$self->FORM->{'model'}->get_iter($path);
            
            #$self->FORM->{'model'}->get_value($iter,0,0);
            my @row=();
            my $sloupec=0;
            if($self->{'ok_butt'}) {
                $sloupec++;
            };
            for(my $j=0;$j<@DBcolumns;$j++) {
                my $pixbuf_col=0;
                if(defined($seznam_struct{'pixbuf'})) {
                    my $this_column=$j;
                    if($self->{'ok_butt'}) {
                          $this_column++;
                    };
                    my @DBcolums=@{$self->{'DBcolumns'}};
                    foreach $_ (@{$seznam_struct{'pixbuf'}}) {
                        if($_ eq $DBcolums[$this_column]) {
                            $pixbuf_col=1;
                        };
                    };
                };
                if($pixbuf_col) {
                    push(@row,' ');
                    $sloupec+=$COL_PIXBUF_SIZE;
                } else {
                    push(@row,$self->FORM->{'model'}->get_value($iter,$sloupec));
                    $sloupec+=$COL_TEXT_SIZE;
                };
            };
            push(@{$print_table{'data'}},[@row]);
        };
        
        $MyMoney{'Printing'}->print_table(%print_table);
    };
};



################################################
#
# Rewrite execs
#
################################################

sub rewrite_datetime_from_sec {
    my $self=shift;
    
    if($self->{'rewrite_data'}) {
        return(strftime("%d.%B %Y %T",localtime($self->{'rewrite_data'})));
    };
    return("");
};

sub rewrite_agendaname_by_id {
    my $self=shift;
    
    if($self->{'rewrite_data'}) {
        my $Databaze=new Databaze(%MyMoney);
        $Databaze->Read('g_Agenda',"id='".$self->{'rewrite_data'}."'","ob_nazev");
        if($Databaze->numrows==1) {
            my %row=$Databaze->fetchhash;
            return($row{'ob_nazev'});
        };
    };
    return("");
};

sub rewrite_ucetnirok_by_id {
    my $self=shift;
    
    if($self->{'rewrite_data'}) {
        my $Databaze=new Databaze(%MyMoney);
        $Databaze->Read('g_Rok',"id='".$self->{'rewrite_data'}."'","ucetni_rok");
        if($Databaze->numrows==1) {
            my %row=$Databaze->fetchhash;
            return($row{'ucetni_rok'});
        };
    };
    return("");
};

sub rewrite_sec_from_datetime {
    my $self=shift;
    if($self->{'rewrite_data'}) {
        my ($datum,$rok,$cas)=split(' ',$self->{'rewrite_data'});
        $rok-=1900;
        $_=$datum;
        my ($den,$mesic)=/^([0-9]*)\.(.*)$/;
        $_=$cas;
        my ($hodina,$minuta,$sekunda)=/^([0-9][0-9]):([0-9][0-9]):([0-9][0-9])$/;
        for(my $i=0;$i<12;$i++) {
            my @tstdate=localtime;
            $tstdate[4]=$i;
            if($mesic eq strftime("%B",@tstdate)) {
                $mesic=$i;
            };
        };
        
        return(strftime("%s",($sekunda,$minuta,$hodina,$den,$mesic,$rok)));

    };
    return(0);
};

sub rewrite_castka_from_db {
    my $self=shift;
    return(Tools::HumanNums(sprintf("%01.2f",$self->{'rewrite_data'})));
    #my $castka=sprintf("%01.2f",$self->{'rewrite_data'});
    #$retval="";
    #my $jednotky=1;
    #for(my $i=length($castka)-1;$i>=0;$i--) {
    #    if($i<length($castka)-4) {
    #        if($jednotky eq 3) {
    #            $retval=" ".$retval;
    #            $jednotky=1;
    #        } else {
    #            $jednotky++;
    #        };
    #    };
    #    $retval=substr($castka,$i,1).$retval;
    #};
    #return($retval);
};

sub rewrite_db_from_castka {
    my $self=shift;
    return(Tools::FromHumanNums($self->{'rewrite_data'}));
    #my $retval=$self->{'rewrite_data'};
    #$retval=~s/ //g;
    #$retval=~s/,/\./;
    #return($retval);
};

sub rewrite_datum_from_db {
    my $self=shift;
    if($self->{'rewrite_data'} eq "0001-01-01") {
        return("");
    };
    my ($rok,$mesic,$den)=split('-',$self->{'rewrite_data'});
    return("$den.$mesic.$rok");
};

sub rewrite_db_from_datum {
    my $self=shift;
    if($self->{'rewrite_data'}) {
        my ($den,$mesic,$rok)=split('\.',$self->{'rewrite_data'});
        return("$rok-$mesic-$den");
    };
    return("0001-01-01");
};

sub rewrite_fv_uzamceni_ico {
    my $self=shift;
    if($self->{'rewrite_data'}) {
        return(Gtk2::Gdk::Pixbuf->new_from_file ("./pixmaps/locked.xpm"));
    };
    return(0);
};

sub rewrite_fv_storno_ico {
    my $self=shift;
    if($self->{'rewrite_data'} eq 'S') {    
        return(Gtk2::Gdk::Pixbuf->new_from_file ("./pixmaps/stornovany.xpm"));
    };
    if($self->{'rewrite_data'} eq 'V') {    
        return(Gtk2::Gdk::Pixbuf->new_from_file ("./pixmaps/stornovaci.xpm"));
    };
    return(0);
};

################################################
#
# Row attributes
#
################################################

sub attr_fv_dobropis {
    my $self=shift;
    my %row=%{$self->{'attr_rowdata'}};
    if($row{'dobropis'} && !$row{'smazano'}) {
        my $numcols=@{$self->{'DBcolumns'}};
        my $startcol=0;
        my $sloupec=2;
        if($self->{'ok_butt'}) {
            $startcol++;
            $sloupec++;
        };
        my %seznam_struct=%{$self->{'seznam_struct'}};
        for(my $i=$startcol;$i<$numcols;$i++) {
            my $pixbuf_col=0;
            if(defined($seznam_struct{'pixbuf'})) {
                my $this_column=$i;
                if($self->{'ok_butt'}) {
                      $this_column++;
                };
                my @DBcolums=@{$self->{'DBcolumns'}};
                foreach $_ (@{$seznam_struct{'pixbuf'}}) {
                    if($_ eq $DBcolums[$this_column]) {
                        $pixbuf_col=1;
                    };
                };
            };
            if($pixbuf_col) {
                $sloupec+=$COL_PIXBUF_SIZE;
            } else {
                $self->{'attr_model'}->set($self->{'attr_iter'},$sloupec,"red");
                $sloupec+=$COL_TEXT_SIZE;
            };
        };
    };
};

sub attr_fv_posplatnosti {
    my $self=shift;
    my %row=%{$self->{'attr_rowdata'}};
    if(!$row{'smazano'} && !$row{dobropis} && ($row{'storno_t'} eq '-') && ($row{uhrazeno} eq "0001-01-01")) {
        my ($rok,$mesic,$den)=split('-',$row{splatno});
        $rok-=1900;
        $mesic--;
        my $melobytzaplaceno=strftime("%s",(59,59,23,$den,$mesic,$rok));
        if($melobytzaplaceno<strftime("%s",localtime)) {
            my $numcols=@{$self->{'DBcolumns'}};
            my $startcol=0;
            my $sloupec=2;
            if($self->{'ok_butt'}) {
                $startcol++;
                $sloupec++;
            };
            my %seznam_struct=%{$self->{'seznam_struct'}};
            for(my $i=$startcol;$i<$numcols;$i++) {
                my $pixbuf_col=0;
                if(defined($seznam_struct{'pixbuf'})) {
                    my $this_column=$i;
                    if($self->{'ok_butt'}) {
                          $this_column++;
                    };
                    my @DBcolums=@{$self->{'DBcolumns'}};
                    foreach $_ (@{$seznam_struct{'pixbuf'}}) {
                        if($_ eq $DBcolums[$this_column]) {
                            $pixbuf_col=1;
                        };
                    };
                };
                if($pixbuf_col) {
                    $sloupec+=$COL_PIXBUF_SIZE;
                } else {
                    $self->{'attr_model'}->set($self->{'attr_iter'},$sloupec,"#30d030");
                    $self->{'attr_model'}->set($self->{'attr_iter'},$sloupec+1,700);    # bold
                    $sloupec+=$COL_TEXT_SIZE;
                };
            };
        };
    };
};

sub attr_fv_smazano {
    my $self=shift;
    my %row=%{$self->{'attr_rowdata'}};
    if($row{'smazano'}) {
        my $numcols=@{$self->{'DBcolumns'}};
        my $startcol=0;
        my $sloupec=1;
        if($self->{'ok_butt'}) {
            $startcol++;
            $sloupec++;
        };
        my %seznam_struct=%{$self->{'seznam_struct'}};
        for(my $i=$startcol;$i<$numcols;$i++) {
            my $pixbuf_col=0;
            if(defined($seznam_struct{'pixbuf'})) {
                my $this_column=$i;
                if($self->{'ok_butt'}) {
                      $this_column++;
                };
                my @DBcolums=@{$self->{'DBcolumns'}};
                foreach $_ (@{$seznam_struct{'pixbuf'}}) {
                    if($_ eq $DBcolums[$this_column]) {
                        $pixbuf_col=1;
                    };
                };
            };
            if($pixbuf_col) {
                $sloupec+=$COL_PIXBUF_SIZE;
            } else {
                $self->{'attr_model'}->set($self->{'attr_iter'},$sloupec,1);
                $self->{'attr_model'}->set($self->{'attr_iter'},$sloupec+1,"blue");
                $sloupec+=$COL_TEXT_SIZE;
            };
        };
    };
};

################################################
#
# Button access
#
################################################

# pracujeme jen s jednim radkem
sub btn_access_fv_kopirovat {
    my $self=shift;

    my %seznam_struct=%{$self->{'seznam_struct'}};
    my $path=$self->FORM->{'treeview'}->get_selection->get_selected_rows;
    my $model=$self->FORM->{'treeview'}->get_model;
    my @DBcolumns=@{$self->{'DBcolumns'}};
    my $sloupec=0;
    for(my $i=0;$i<@DBcolumns;$i++) {
        if($DBcolumns[$i] eq "storno_t") {
            if($model->get($model->get_iter($path),$sloupec+1) eq "V") {
                return(0);
            } else {
                return(1);
            };
        };
        my $pixbuf_col=0;
        if(defined($seznam_struct{'pixbuf'})) {
            my $this_column=$i;
            if($self->{'ok_butt'}) {
                  $this_column++;
            };
            my @DBcolums=@{$self->{'DBcolumns'}};
            foreach $_ (@{$seznam_struct{'pixbuf'}}) {
                if($_ eq $DBcolums[$this_column]) {
                    $pixbuf_col=1;
                };
            };
        };
        if($pixbuf_col) {
            $sloupec+=$COL_PIXBUF_SIZE;
        } else {
            $sloupec+=$COL_TEXT_SIZE;
        };
    };
    return(0);
};

# pracujeme jen s jednim radkem
sub btn_access_fv_storno {
    my $self=shift;

    my %seznam_struct=%{$self->{'seznam_struct'}};
    my $path=$self->FORM->{'treeview'}->get_selection->get_selected_rows;
    my $model=$self->FORM->{'treeview'}->get_model;
    my @DBcolumns=@{$self->{'DBcolumns'}};
    my $sloupec=0;
    for(my $i=0;$i<@DBcolumns;$i++) {
        if($DBcolumns[$i] eq "storno_t") {
            if($model->get($model->get_iter($path),$sloupec+1) ne "-") {
                return(0);
            };
        };
        my $pixbuf_col=0;
        if(defined($seznam_struct{'pixbuf'})) {
            my $this_column=$i;
            if($self->{'ok_butt'}) {
                  $this_column++;
            };
            my @DBcolums=@{$self->{'DBcolumns'}};
            foreach $_ (@{$seznam_struct{'pixbuf'}}) {
                if($_ eq $DBcolums[$this_column]) {
                    $pixbuf_col=1;
                };
            };
        };
        if($pixbuf_col) {
            $sloupec+=$COL_PIXBUF_SIZE;
        } else {
            $sloupec+=$COL_TEXT_SIZE;
        };
    };
    foreach $_ (@{$seznam_struct{'dbcols_tool'}}) {
        if($_ eq "smazano") {
            if($model->get($model->get_iter($path),$sloupec) eq 0) {
                return(1);
            } else {
                return(0);
            };
        };
        $sloupec++;
    };
    return(0);
};

# pracujeme s jednim radkem
sub btn_access_fv_smazat {
    my $self=shift;

    my %seznam_struct=%{$self->{'seznam_struct'}};
    my $path=$self->FORM->{'treeview'}->get_selection->get_selected_rows;
    my $model=$self->FORM->{'treeview'}->get_model;
    my @DBcolumns=@{$self->{'DBcolumns'}};
    my $possible_rows=0;
    my $sloupec=0;
    my $row_fail=0;
    for(my $i=0;$i<@DBcolumns;$i++) {
        if($DBcolumns[$i] eq "storno_t") {
            if($model->get($model->get_iter($path),$sloupec+1) eq "S") {
                $row_fail=1;
            };
        };
        my $pixbuf_col=0;
        if(defined($seznam_struct{'pixbuf'})) {
            my $this_column=$i;
            if($self->{'ok_butt'}) {
                  $this_column++;
            };
            my @DBcolums=@{$self->{'DBcolumns'}};
            foreach $_ (@{$seznam_struct{'pixbuf'}}) {
                if($_ eq $DBcolums[$this_column]) {
                    $pixbuf_col=1;
                };
            };
        };
        if($pixbuf_col) {
            $sloupec+=$COL_PIXBUF_SIZE;
        } else {
            $sloupec+=$COL_TEXT_SIZE;
        };
    };
    foreach $_ (@{$seznam_struct{'dbcols_tool'}}) {
        if($_ eq "smazano") {
            if($model->get($model->get_iter($path),$sloupec) eq 1) {
                $row_fail=1;
            };
        };
        $sloupec++;
    };
    if($row_fail) {
        return(0);
    };
    return(1);
};


1;
