#!/usr/bin/perl -w

package SeznamDef;

use strict;

use utf8;
#use open ':utf8', ':std';

my %Seznam=();

$Seznam{"dead_locks"}={
        "title"      =>  "Seznam zamku tabulek",
        "table"      =>  "g_Locks",
        "where"      =>  "",
        "labels"     =>  ["Číslo zamku","Blokováno uživatelem","Blokováno od","Proces ID","Pocitac","Agenda","Ucetni rok","Tabulka","Klic uzamceneho zaznamu"],
        "dbcols"     =>  ["id","user_name","time","pid","hostname","agenda_id","rok_id","tablename","tablekey"],
        "primary_column"    =>  "id",
        "right_align"    =>  ["pid"],
        "cb_upravit"    =>  "Locks",
        "rewrite"   =>  {
			"user_name"=>{"-"=>"uživatel beze jména"},
                        "time"=>["rewrite_datetime_from_sec","rewrite_sec_from_datetime"],
                        "agenda_id"=>["rewrite_agendaname_by_id"],
                        "rok_id"=>["rewrite_ucetnirok_by_id"],
			}
};

$Seznam{"konstantni_symboly"}={
        "title"      =>  "Seznam konstantních symbolů",
        "table"      =>  "g_SzKonSym",
        "where"      =>  "",
        "labels"     =>  ["Kon. sym.","Popis"],
        "dbcols"     =>  ["konsym","popis"],
        "primary_column"    =>  "konsym",
        "cb_upravit"    =>  "KonSym"
};

$Seznam{"banky"}={
        "title"      =>  "Seznam peněžních ústavů",
        "table"      =>  "g_Banky",
        "where"      =>  "",
        "labels"     =>  ["Kód","Název","Zkratka","SWIFT","Kód státu"],
        "dbcols"     =>  ["kod","nazev","zkrat","swift","kodstatu"],
        "primary_column"    =>  "kod",
        "cb_upravit"    =>  "PenezniUstav"
};

$Seznam{"psc"}={
        "title"      =>  "Seznam PSČ",
        "table"      =>  "g_Psc",
        "where"      =>  "",
        "labels"     =>  ["PSČ","Místo","Pošta","Tel. před."],
        "dbcols"     =>  ["psc","misto","posta","telpred"],
        "dbcols_tool"   =>  ["id"],
        "primary_column"    =>  "id",
        "cb_upravit"    =>  "KartaPsc"
};

$Seznam{"staty"}={
        "title"      =>  "Seznam států",
        "table"      =>  "g_Staty",
        "where"      =>  "",
        "labels"     =>  ["Kód","Popis","EU","Kód DIČ"],
        "dbcols"     =>  ["kod","popis","eu","koddic"],
        "rewrite"   =>  {"eu"=> {0=>"Ne",1=>"Ano"}},
        "primary_column"    =>  "kod",
        "cb_upravit"    =>  "KartaStatu"
};

$Seznam{"ucty"}={
        "title"      =>  "Seznam bankovních účtů",
        "table"      =>  "r_SzUcPokl",
        "where"      =>  "ucpokl='U'",
        "labels_P"     =>  ["Zkratka","Popis","Účet","Kód","SWIFT","IBAN","Primární účet"],
        "dbcols_P"     =>  ["zkrat","popis","ucet","bkod","swift","iban","primucet"],
        "labels_J"     =>  ["Zkratka","Popis","Účet","Kód","SWIFT","IBAN"],
        "dbcols_J"     =>  ["zkrat","popis","ucet","bkod","swift","iban"],
        "primary_column"    =>  "zkrat",
        "cb_upravit"      =>   "UcetPokladna"
};
    
$Seznam{"pokladny"}={
        "title"      =>  "Seznam pokladen",
        "table"      =>  "r_SzUcPokl",
        "where"      =>  "ucpokl='P'",
        "labels_P"     =>  ["Zkratka","Popis","Pokladní","Primární účet"],
        "dbcols_P"     =>  ["zkrat","popis","pokladni","primucet"],
        "labels_J"     =>  ["Zkratka","Popis","Pokladní"],
        "dbcols_J"     =>  ["zkrat","popis","pokladni"],
        "primary_column"    =>  "zkrat",
        "cb_upravit"    =>  "UcetPokladna"
};

$Seznam{"ucty_pokladny"}={
        "title"      =>  "Seznam bankovních účtů a pokladen",
        "table"      =>  "r_SzUcPokl",
        "where"      =>  "",
        "labels_P"     =>  ["Zkratka","Popis","Pokladní","Účet","Kód","SWIFT","IBAN","Primární účet"],
        "dbcols_P"     =>  ["zkrat","popis","pokladni","ucet","bkod","swift","iban","primucet"],
        "labels_J"     =>  ["Zkratka","Popis","Pokladní","Účet","Kód","SWIFT","IBAN"],
        "dbcols_J"     =>  ["zkrat","popis","pokladni","ucet","bkod","swift","iban"],
        "primary_column"    =>  "zkrat",
        "cb_upravit"    =>  "UcetPokladna"
};

$Seznam{"strediska"}={
        "title"      =>  "Seznam středisek",
        "table"      =>  "r_SzStred",
        "where"      =>  "",
        "labels"     =>  ["Zkratka","Název"],
        "dbcols"     =>  ["zkrat","nazev"],
        "primary_column"    =>  "zkrat",
        "cb_upravit"    =>  "KartaStrediska"
};

$Seznam{"cinnosti"}={
        "title"      =>  "Seznam činností",
        "table"      =>  "r_SzCinn",
        "where"      =>  "",
        "labels"     =>  ["Zkratka","Název"],
        "dbcols"     =>  ["zkrat","nazev"],
        "primary_column"    =>  "zkrat",
        "cb_upravit"    =>  "Cinnost"
};

$Seznam{"zakazky"}={
        "title"      =>  "Seznam zakázek",
        "table"      =>  "r_Zakazky",
        "where"      =>  "",
        "labels"     =>  ["Zkratka","Název"],
        "dbcols"     =>  ["zkrat","nazev"],
        "primary_column"    =>  "zkrat",
        "cb_upravit"    =>  "Zakazka"
};

$Seznam{"ciselne_rady"}={
        "title"      =>  "Číselné řady dokladů",
        "table"      =>  "r_CisRady",
        "where"      =>  "",
        "labels"     =>  ["Řada","Číslo","Název","Středisko"],
        "dbcols"     =>  ["rada","cislo","nazev","stred"],
        "primary_column"    =>  "rada",
        "cb_upravit"    =>  "CiselnaRada"
};

$Seznam{"volna_cisla"}={
        "title"      =>  "Seznam volných čísel",
        "table"      =>  "r_VolneCis",
        "where"      =>  "",
        "labels"     =>  ["Řada","Číslo","Nenabízet","Blokováno uživatelem","Blokováno od"],
        "dbcols"     =>  ["rada","cislo","nenab","uzivatel","in_use"],
        "rewrite"   =>  {
			"nenab"=> {0=>"Ne",1=>"Ano"},
			"uzivatel"=>{"-"=>"uživatel beze jména"},
                        "in_use"=>["rewrite_datetime_from_sec","rewrite_sec_from_datetime"]
			}
};

$Seznam{"predkontace_P"}={
        "title"      =>  "Seznam předkontací",
        "table"      =>  "r_UcPrKont_P",
        "where"      =>  "",
        "labels"     =>  ["Zkratka","Popis","Účet MD","Účet D"],
        "dbcols"     =>  ["zkrat","popis","ucmd","ucd"],
        "primary_column"    =>  "zkrat",
        "cb_upravit"    =>  "PredkontaceP"
};

$Seznam{"predkontace_J"}={
        "title"      =>  "Seznam předkontací",
        "table"      =>  "r_UcPrKont_J",
        "where"      =>  "",
        "labels"     =>  ["Zkratka","Popis"],
        "dbcols"     =>  ["zkrat","popis"],
        "primary_column"    =>  "zkrat",
        "cb_upravit"    =>  "PredkontaceJ"
};

$Seznam{"cleneni"}={
        "title"      =>  "Seznam členění DPH",
        "table"      =>  "r_UcClnDPH",
        "where"      =>  "",
        "labels"     =>  ["Zkratka","Popis","Typ","Kolonka v přiznání DPH","Kód plnění"],
        "dbcols"     =>  ["zkrat","popis","typ","kolonka","kodplneni"],
        "rewrite"   =>  {
                         "typ"=> {
                                  "U"=>"Uskutečněná",
                                  "P"=>"Přijatá"
                                  },
                         "kodplneni"=>{
                                       0=>"",
                                       1=>"0 - Dodání zboží",
                                       2=>"1 - Přemístění obch. majetku",
                                       3=>"2 - Třístranné obchody"
                                       },
                         "kolonka"=>{
                                    "NN" => "Neovlivňuje přiznání k DPH",
                                    "PT" => "Přijatá zdaň. plnění z tuzemska - má nárok na odpočet",
                                    "KT" => "Přijatá zdaň. plnění z tuzemska - krátit nárok na odpočet",
                                    "P1" => "Pořízení zboží z jiného členského státu",
                                    "K1" => "Pořízení zboží z jiného členského státu - krác. nár.",
                                    "P2" => "Poskytnutí služby osobou reg. k dani v jiném člen. státě",
                                    "K2" => "Poskytnutí služby osobou reg. k dani v jiném člen. státě - krác. nár.",
                                    "P4" => "Pořízení dopr. prostředku - od osob reg. k dani v jiném čl. státě",
                                    "K4" => "Pořízení dopr. prostředku - od osob reg. k dani v jiném čl. státě - krác. nár",
                                    "P5" => "Pořízení dopr. prostředku - od osbob nereg. k dani v jiném čl. státě",
                                    "K5" => "Pořízení dopr. prostředku - od osob nereg. k dani v jiném čl. státě - krác. nár.",
                                    "P6" => "Dovoz zboží",
                                    "K6" => "Dovoz zboží - krác. nár.",
                                    "P7" => "Poskytnutí služby zahraniční osobou povinnou k dani",
                                    "K7" => "Poskytnutí služby zahraniční osobou povinnou k dani - krác. nár.",
                                    "PX" => "Pořízení zboží prostřední osobou (Souhrnné hlášení)",
                                    "VD" => "Vrácená daň zahraničním fyzickým osobám",
                                    "UT" => "Uskutečněná zdaň. plnění v tuzemsku",
                                    "R1" => "Pořízení zboží z jiného člen. státu",
                                    "R2" => "Poskytnutí služby osobou reg. k dani v jiném člen. státě",
                                    "R3" => "Zaslání zboží z jiného člen. státu s místem plnění v tuzemsku",
                                    "R4" => "Pořízení dopr. prostředku - od osob reg. k dani v jiném čl. státě",
                                    "R5" => "Pořízení dopr. prostředku - od osob nereg. k dani v jiném čl. státě",
                                    "R6" => "Dovoz zboží",
                                    "R7" => "Poskytnutí služby zahraniční osobou povinnou k dani",
                                    "U1" => "Dodání zboží do jiného členského státu",
                                    "U3" => "Dodání dopr. prostředku - osobě reg. k dani v jiném čl, státě",
                                    "U2" => "Dodání dopr. prostředku - osobě nereg. k dani v jiném čl. státě",
                                    "VZ" => "Vývoz zboží",
                                    "U4" => "Ostatní plnění osvobozená od daně s nárokem na odpočet",
                                    "U0" => "Uskut. zdan. plnění osvobozená, příp. se zdan. plněním mimo tuzemsko",
                                    "UX" => "Dodání zboží prostř. osobou (Souhrnné hlášení)"
                                    }
                         },
        "primary_column"    =>  "zkrat",
        "cb_upravit"    =>  "CleneniDPH"
};

$Seznam{"uctova_osnova"}={
        "title"      =>  "Účtová osnova",
        "table"      =>  "r_UcOsnova",
        "where"      =>  "",
        "labels"     =>  ["Účet","Název","Druh","Typ","Podtyp","Opravkový","Vnitropodnikový","Technický","Účet převodu"],
        "dbcols"     =>  ["ucet","nazev","druhuctu","ucettyp","ucetpodtyp","opravky","vnitro","technicky","ucprev"],
        "rewrite"   =>  {
                         "druhuctu"=> {
                                  "R"=>"Rozvahový",
                                  "V"=>"Výsledkový",
                                  "Z"=>"Závěrkový",
                                  "P"=>"Podrozvahový"
                                  },
                         "ucettyp"=>{
                                       0=>"Aktivní",
                                       1=>"Pasivní",
                                       2=>"Nákladový",
                                       3=>"Výnosový",
                                       4=>""
                                       },
                         "ucetpodtyp"=>{
                                       0=>"Nesledovat saldo",
                                       1=>"Sledovat saldo",
                                       2=>"Ovlivňující daň z příjmu",
                                       3=>"Neovlivňující daň z příjmu",
                                       4=>"Sledovat zůstatek na MD",
                                       4=>"Sledovat zůstatek na DAL",
                                       },
                         "opravky"=>{
                                       0=>"Ne",
                                       1=>"Ano"
                                       },
                         "vnitro"=>{
                                       0=>"Ne",
                                       1=>"Ano"
                                       },
                         "technicky"=>{
                                       0=>"Ne",
                                       1=>"Ano"
                                       },
                         },
        "primary_column"    =>  "ucet",
        "cb_upravit"    =>  "UcetUctoveOsnovy"
};


$Seznam{"ucetni_pohyby"}={
        "title"      =>  "Seznam účetních pohybů",
        "table"      =>  "r_UcPohyby",
        "where"      =>  "",
        "labels"     =>  ["Zkratka","Popis"],
        "dbcols"     =>  ["zkrat","popis"],
        "primary_column"    =>  "zkrat",
        "cb_upravit"    =>  "KartaUcetnihoPohybu"
};

$Seznam{"ucetni_pohyby_P"}={
        "title"      =>  "Seznam účetních pohybů",
        "table"      =>  "r_UcPohyby",
        "where"      =>  "typ='P'",
        "labels"     =>  ["Zkratka","Popis"],
        "dbcols"     =>  ["zkrat","popis"],
        "primary_column"    =>  "zkrat",
        "cb_upravit"    =>  "KartaUcetnihoPohybu"
};

$Seznam{"ucetni_pohyby_V"}={
        "title"      =>  "Seznam účetních pohybů",
        "table"      =>  "r_UcPohyby",
        "where"      =>  "typ='V'",
        "labels"     =>  ["Zkratka","Popis"],
        "dbcols"     =>  ["zkrat","popis"],
        "primary_column"    =>  "zkrat",
        "cb_upravit"    =>  "KartaUcetnihoPohybu"
};

$Seznam{"vystavene_faktury"}={
        "title"      =>  "Seznam faktur vystavených",
        "table"      =>  "r_VFaktury",
        "where"      =>  "",
        "labels"     =>  [" Z"," S","Číslo dokladu","Odběratel","Popis faktury","Celkem s DPH","K úhradě s DPH","Proplatit","Fakturační adresa","Var. symbol","Konečný příjemce","Vystaveno","Plnění DPH","Splatno","Uhrazeno","Doručeno","Základ","Středisko","Zakázka","IČO","Číslo objednávky","Řádek"],
        "dbcols"     =>  ["uzamceni","storno_t","doklad","o_nazev","popis","kuhradesdp","kuhradesdp","proplatit","of_nazev","varsymbol","k_nazev","vystaveno","plnenodph","splatno","uhrazeno","doruceno","zaklad_3","stredisko","zakazka","o_ico","cobjednavky","cislo"],
        "dbcols_tool"   =>  ["dobropis","smazano"],
        "rewrite"   =>  {
                "uzamceni"  =>  ["rewrite_fv_uzamceni_ico"],
                "storno_t"  =>  ["rewrite_fv_storno_ico"],
                "kuhradesdp"=> ["rewrite_castka_from_db","rewrite_db_from_castka"],
                "proplatit"=> ["rewrite_castka_from_db","rewrite_db_from_castka"],
                "vystaveno"=> ["rewrite_datum_from_db","rewrite_db_from_datum"],
                "plnenodph"=> ["rewrite_datum_from_db","rewrite_db_from_datum"],
                "splatno"=> ["rewrite_datum_from_db","rewrite_db_from_datum"],
                "uhrazeno"=> ["rewrite_datum_from_db","rewrite_db_from_datum"],
                "doruceno"=> ["rewrite_datum_from_db","rewrite_db_from_datum"],
                "zaklad_0"=> ["rewrite_castka_from_db","rewrite_db_from_castka"]
                },
        "right_align"    =>  ["cislo","celkemsdph","kuhradesdp","proplatit","zaklad_0"],
        "row_attr" =>  ["attr_fv_dobropis","attr_fv_smazano","attr_fv_posplatnosti"],
        "pixbuf"    =>  ["uzamceni","storno_t"],
        "primary_column"    =>  "cislo",
        "legenda"    =>  "faktury",
        "printing_menu" =>  1,
        "button_access" => {
                            "button_kopirovat" =>  "btn_access_fv_kopirovat",
                            "button_storno" =>  "btn_access_fv_storno",
                            "button_smazat" =>  "btn_access_fv_smazat"
                           },
        "cb_upravit"    =>  "FakturaVystavena"

};

$Seznam{"adresni_skupiny"}={
        "title"      =>  "Seznam adresnich skupin",
        "table"      =>  "a_AdrSkup",
        "where"      =>  "",
        "labels"     =>  ["Nazev","Zkratka","Řádek"],
        "dbcols"     =>  ["nazev","zkrat","id"],
        "right_align"    =>  ["id"],
        "primary_column"    =>  "id",
        "cb_upravit"    =>  "KartaSkupinyAdresare"

};

sub get {
    my($seznam_hash)=@_;
    return($Seznam{$seznam_hash});
};

1;
